#bibliotheques
from PIL import Image
from PIL import ImageOps
import numpy #Pour manipuler des tableaux de nombres
import random




#partie 1:
im = Image.open("D:/fichierspython/photogris.bmp") #crée un objet im qui contient l'image située à l'adresse indiquée
size = im.size    #méthode size récupère les dimensions largeur/hauteur
print(size)
data = list(im.getdata()) #la methode getdata permet de récuperer les valeurs des pixels, ici mise en liste 
print(data)


#partie 2:
def OuvrirImgGris(path):
    im = Image.open(str(path))   #crée un objet im qui contient l'image située à l'adresse indiquée
    largeur,hauteur = im.size   #méthode size récupère les dimensions
    imdata=im.getdata()  #la methode getdata permet de récuperer les valeurs des pixels en liste
    tab=numpy.array(imdata)  #met les données en tableau
    matrix = numpy.reshape(tab,(hauteur,largeur))  #met les données sous forme de matrice
    return matrix


matrice1=OuvrirImgGris("D:/fichierspython/photogris.bmp")
#print(matrice1)
#print(matrice1.shape)

#créer une image a partir d'une matrice
def CreerImgGris(matrix,path): #matrice de l'image à reconstruire, plus chemin de sortie.
    size=(matrix.shape[1],matrix.shape[0]) #entre matrice et image l'ordre des dimensions est inversé
    im2 = Image.new("L",size)
    im2.putdata(list(matrix.flat))
    im2.save(fp=str(path))

#pixelliser

matrice2=numpy.array([[0]*320]*240) 

for i in range (240):
    for j in range(320):
        matrice2[i][j]=matrice1[i*2][j*2 ]

CreerImgGris(matrice2,"D:/fichierspython/photogrispixellisee.bmp")    

#passer en noir et blanc    

matrice2=numpy.array([[0]*640]*480) #crée une matrice de 0 de taille 480 lignes 640 colonnes

for i in range (480):
    for j in range(640):
       
        if matrice1[i][j]>127:
            y=255
        else :
            y=0
               
        matrice2[i][j]=y
            


CreerImgGris(matrice2,"D:/fichierspython/photoNB.bmp")


#contraste    
from math import sqrt

matrice2=numpy.array([[0]*640]*480) #crée une matrice de 0 de taille 478 lignes 640 colonnes

for i in range (480):
    for j in range(640):
        y= matrice1[i][j]**2//255 
        
               
        matrice2[i][j]=y
            


CreerImgGris(matrice2,"D:/fichierspython/photocarre.bmp")


#filtres



def filtrage(matrice1,filtre):
    matrice2=numpy.array([[0]*640]*480) #crée une matrice de 0 de taille 480 lignes 640 colonnes
    for i in range (1,479):
        for j in range(1,639):
            y=0
            for k in range(-1,2):
                for l in range(-1,2):
                    y=y+ matrice1[i+k][j+l]*filtre[k+1][l+1]
            matrice2[i][j]=y
    return matrice2

filtremoyenne=numpy.array([[1/9]*3]*3)

# restauration de la fleur

matricefleur=OuvrirImgGris("D:/fichierspython/fleurabimee.bmp")
#code qui a servi a abimer l'image fleur au depart dans une amtrice mat
#for i in range(480):
#    for j in range(640):
#        if random.random()<0.10:
#            mat[i][j]=random.randint(0,255)
#CreerImgGris(mat,"D:/fichierspython/fleurabimee.bmp")        


matrice2=filtrage(matricefleur,filtremoyenne)
CreerImgGris(matrice2,"D:/fichierspython/photomoyenne.bmp")

#detection des contours

Gx=numpy.array([[0,0,0],[0,-1,1],[0,0,0]])
Gy=numpy.array([[0,0,0],[0,-1,0],[0,1,0]])
mx=filtrage(matrice1,Gx)    
my=filtrage(matrice1,Gy) 
grad=numpy.sqrt(mx**2+my**2)


for i in range (480):
    for j in range(640):
        if grad[i][j]>15:
            grad[i][j]=0
        else:
            grad[i][j]=255
            
CreerImgGris(grad,"D:/fichierspython/photogradient.bmp")